<?php

namespace ISYS\UBRIR;

use UBRIR\Core;
use \UBRIR\GatewayForAdmin;

class OpencartAdmin extends GatewayForAdmin
{
    private $controller;
    private $connector;

    function __construct(\Controller $controller)
    {
        $connector = new OpencartUBRiRConnector($controller);
        $this->controller = $controller;
        $this->connector = $connector;
        parent::__construct($connector);
    }

    //Для тех окружений где недоступно однострочное создание объекта класса вроде (new WordpressAdmin())->ShowOrders() можно использовать WordpressAdmin::ShowOrders()
    static function __callStatic($functionName, $arguments)
    {
        if (static::$__callCache == null) {
            parent::_fillCallCache();
        }

        if (isset(static::$__callCache[$functionName])) {
            $className = __CLASS__;
            $GatewayForAdmin = new $className();

            return $GatewayForAdmin->$functionName($arguments);
        }

        return NULL;
    }

    public function GetAdminEmail()
    {
        $admin_email = $this->controller->config->get('config_email');
        return $admin_email;
    }

    public function GetShopId()
    {
        return $this->connector->GetShopId();

    }

    public function SetCertCreationDate()
    {
        $this->connector->UpdateCertificateCreateDate();
    }

    public function GetCertCreationDate()
    {
        return $this->connector->GetCertificateCreateDate();

    }

    public function CleanLog()
    {
        $core = Core::GetCore();
        $core->CleanLog();
    }

//    public static function SendTestMailNotification()
//    {
//        $optionValues = Array();
//        $adminEmail = get_option('admin_email');
//
//        $mailNotification = new WordpressPaymentMailNotification();
//        $resultData = new \UBRIR\PaymentResultViewer();
//
//        $resultData
//            ->SetPaymentTime("01/06/2017 12:00:00")
//            ->SetShopOrderId('100')
//            ->SetTWPG_OrderId('2000')
//            ->SetCardPAN('XXXXXXXXXX8884')
//            ->SetCardOwner('Test Testovich')
//            ->SetPaymentAmount('2.00')
//            ->SetOperationType('Покупка');
//
//        $mailNotification->ConnectResultViewer($resultData);
//
//        if ($mailNotification->SendPaymentNotification($adminEmail)) {
//            $arResult = Array('success' => true, 'message' => 'Письмо доставлено');
//        } else {
//            $arResult = Array('success' => false, 'message' => 'Не удалось отправить почтовое уведомление!');
//        }
//
//        echo json_encode($arResult);
//    }
}