<?php

namespace UBRIR;

class CoreAutoLoader
{
    public static function register($class)
    {
        // UBRIR.Core namespace prefix
        $prefix = 'UBRIR\\';

        // does the class use the namespace prefix?
        $len = strlen($prefix);
        if (strncmp($prefix, $class, $len) !== 0) {
            // no, move to the next registered autoloader
            return;
        }

        $base_dir = __DIR__ . '/';
        $base_dir = realpath($base_dir . '../ubrr.core/classes/');

        // get the relative class name
        $relative_class = substr($class, $len);

        // replace the namespace prefix with the base directory, replace namespace
        // separators with directory separators in the relative class name, append
        // with .php
        $file = $base_dir . '/' . str_replace('\\', '/', $relative_class) . '.php';
        $ubrir_file = $base_dir . '/' . 'UBRIR_' . str_replace('\\', '/', $relative_class) . '.php';

        // if the file exists, require it
        if (file_exists($file)) {
            require $file;
        } else {
            if (file_exists($ubrir_file)) {
                require $ubrir_file;
            }
        }
    }
}

spl_autoload_register('UBRIR\CoreAutoLoader::register');